"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

var _core = require("@material-ui/core");

var _ipmdDDL = _interopRequireDefault(require("./ipmdDDL"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const IPMDEKATTE = _ref => {
  let {
    ekatteId,
    setValue,
    readOnly,
    horizontal,
    funcRequest,
    maxFields = 3,
    ekatteStruct,
    funcTranslate,
    emptySign = "--"
  } = _ref;
  const [ekatteError, setEkatteError] = (0, _react.useState)({
    isWrong: false,
    message: ""
  });
  const load = (0, _react.useCallback)(async id => {
    // if ekatteId should be returned back use setValue:
    if (setValue) setValue(id); // if not func there will be no res

    try {
      if (funcRequest) {
        funcRequest(id); // setEkatteStruct(res); - done outside in the request function due to the nature of HttpRequest()
      }
    } catch (err) {
      console.log("I have got an error");
      setEkatteError({
        isWrong: true,
        message: err.message || "EKATTE Bad or no server response"
      });
    }
  }, [funcRequest, setValue]);
  (0, _react.useEffect)(() => {
    load(ekatteId); // eslint-disable-next-line
  }, [load]); // if horizontal is set

  const horizontaSplit = horizontal ? 12 / (ekatteStruct && (ekatteStruct.length < maxFields ? ekatteStruct.length : maxFields)) : 12;
  const emptyOption = {
    value: "",
    label: emptySign
  };
  return /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    spacing: 1
  }, ekatteStruct && ekatteStruct.length > 0 && ekatteStruct.map((item, idx) => idx < maxFields ?
  /*#__PURE__*/
  // if limit in number of fields set
  _react.default.createElement(_core.Grid, {
    item: true,
    xs: horizontaSplit,
    key: idx
  }, /*#__PURE__*/_react.default.createElement(_ipmdDDL.default, {
    label: funcTranslate ? funcTranslate(item.level) : item.level,
    value: item.value !== null ? item : emptyOption,
    setValue: e => load(e.value),
    menu: [emptyOption, ...item.menu.map(x => {
      return {
        value: x.ekatteId,
        label: x.name
      };
    })],
    readOnly: readOnly || !item.menu
  })) : null), ekatteError && ekatteError.isWrong && /*#__PURE__*/_react.default.createElement("label", null, ekatteError.message));
};

var _default = IPMDEKATTE;
exports.default = _default;